\def\filedate{2018/06/26}
\def\fileversion{1.0-dev}

\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{beamercolorthemeustutt}[\filedate\space Version \fileversion\space by Philipp Tempel <philipp.tempel@isw.uni-stuttgart.de>]

\RequirePackage{pgfopts}

\providecommand{\colorlighter}[3]{%
  \colorlet{#3}{#1!#2!White}%
}
\providecommand{\colordarker}[3]{%
  \colorlet{#3}{#1!#2!Black}%
}

\pgfkeys{%
  /ustutt/color/block/.cd,%
    .is choice,%
    transparent/.code=\ustutt@block@transparent,%
    fill/.code=\ustutt@block@fill,%
}
\pgfkeys{%
  /ustutt/color/accent/.cd,%
    .is choice,%
    bright/.code=\ustutt@colors@bright,%
    dark/.code=\ustutt@colors@dark,%
}
\newcommand{\ustutt@color@setdefaults}{%
  \pgfkeys{/ustutt/color/.cd,%
    accent=dark,%
    block=transparent,%
  }
}

% Define colors
\definecolor{UStuttDarkOne}{RGB}{62,68,76} % Anthracite
\definecolor{UStuttDarkTwo}{RGB}{0,0,0} % Black
\definecolor{UStuttLightOne}{RGB}{255,255,255} % White
\definecolor{UStuttLightTwo}{RGB}{159,153,152} % Light gray
\definecolor{UStuttAccent1}{RGB}{0,190,255} % Turquoise blue
\definecolor{UStuttAccent2}{RGB}{9,81,158} % Dark blue
\definecolor{UStuttAccent3}{RGB}{62,68,76} % Anthracite
\definecolor{UStuttAccent4}{RGB}{125,198,234} % Light blue-gray
\definecolor{UStuttAccent5}{RGB}{159,153,152} % Light gray
\definecolor{UStuttAccent6}{RGB}{255,213,0}% Yellow

\colorlighter{UStuttDarkOne}{25}{UStuttDarkOneVeryLight}
\colorlighter{UStuttDarkOne}{50}{UStuttDarkOneLight}
\colorlighter{UStuttDarkOne}{75}{UStuttDarkOneLighter}
\colordarker{UStuttDarkOne}{50}{UStuttDarkOneDark}
\colordarker{UStuttDarkOne}{75}{UStuttDarkOneDarker}
\colordarker{UStuttDarkOne}{25}{UStuttDarkOneVeryDark}

\colorlighter{UStuttDarkTwo}{25}{UStuttDarkTwoVeryLight}
\colorlighter{UStuttDarkTwo}{50}{UStuttDarkTwoLight}
\colorlighter{UStuttDarkTwo}{75}{UStuttDarkTwoLighter}
\colordarker{UStuttDarkTwo}{50}{UStuttDarkTwoDark}
\colordarker{UStuttDarkTwo}{75}{UStuttDarkTwoDarker}
\colordarker{UStuttDarkTwo}{25}{UStuttDarkTwoVeryDark}

\colorlighter{UStuttLightOne}{25}{UStuttLightOneVeryLight}
\colorlighter{UStuttLightOne}{50}{UStuttLightOneLight}
\colorlighter{UStuttLightOne}{75}{UStuttLightOneLighter}
\colordarker{UStuttLightOne}{50}{UStuttLightOneDark}
\colordarker{UStuttLightOne}{75}{UStuttLightOneDarker}
\colordarker{UStuttLightOne}{25}{UStuttLightOneVeryDark}

\colorlighter{UStuttLightTwo}{25}{UStuttLightTwoVeryLight}
\colorlighter{UStuttLightTwo}{50}{UStuttLightTwoLight}
\colorlighter{UStuttLightTwo}{75}{UStuttLightTwoLighter}
\colordarker{UStuttLightTwo}{50}{UStuttLightTwoDark}
\colordarker{UStuttLightTwo}{75}{UStuttLightTwoDarker}
\colordarker{UStuttLightTwo}{25}{UStuttLightTwoVeryDark}

\colorlighter{UStuttAccent1}{25}{UStuttAccent1VeryLight}
\colorlighter{UStuttAccent1}{50}{UStuttAccent1Light}
\colorlighter{UStuttAccent1}{75}{UStuttAccent1Lighter}
\colordarker{UStuttAccent1}{50}{UStuttAccent1Dark}
\colordarker{UStuttAccent1}{75}{UStuttAccent1Darker}
\colordarker{UStuttAccent1}{25}{UStuttAccent1VeryDark}

\colorlighter{UStuttAccent2}{25}{UStuttAccent2VeryLight}
\colorlighter{UStuttAccent2}{50}{UStuttAccent2Light}
\colorlighter{UStuttAccent2}{75}{UStuttAccent2Lighter}
\colordarker{UStuttAccent2}{50}{UStuttAccent2Dark}
\colordarker{UStuttAccent2}{75}{UStuttAccent2Darker}
\colordarker{UStuttAccent2}{25}{UStuttAccent2VeryDark}

\colorlighter{UStuttAccent3}{25}{UStuttAccent3VeryLight}
\colorlighter{UStuttAccent3}{50}{UStuttAccent3Light}
\colorlighter{UStuttAccent3}{75}{UStuttAccent3Lighter}
\colordarker{UStuttAccent3}{50}{UStuttAccent3Dark}
\colordarker{UStuttAccent3}{75}{UStuttAccent3Darker}
\colordarker{UStuttAccent3}{25}{UStuttAccent3VeryDark}

\colorlighter{UStuttAccent4}{25}{UStuttAccent4VeryLight}
\colorlighter{UStuttAccent4}{50}{UStuttAccent4Light}
\colorlighter{UStuttAccent4}{75}{UStuttAccent4Lighter}
\colordarker{UStuttAccent4}{50}{UStuttAccent4Dark}
\colordarker{UStuttAccent4}{75}{UStuttAccent4Darker}
\colordarker{UStuttAccent4}{25}{UStuttAccent4VeryDark}

\colorlighter{UStuttAccent5}{25}{UStuttAccent5VeryLight}
\colorlighter{UStuttAccent5}{50}{UStuttAccent5Light}
\colorlighter{UStuttAccent5}{75}{UStuttAccent5Lighter}
\colordarker{UStuttAccent5}{50}{UStuttAccent5Dark}
\colordarker{UStuttAccent5}{75}{UStuttAccent5Darker}
\colordarker{UStuttAccent5}{25}{UStuttAccent5VeryDark}

\colorlighter{UStuttAccent6}{25}{UStuttAccent6VeryLight}
\colorlighter{UStuttAccent6}{50}{UStuttAccent6Light}
\colorlighter{UStuttAccent6}{75}{UStuttAccent6Lighter}
\colordarker{UStuttAccent6}{50}{UStuttAccent6Dark}
\colordarker{UStuttAccent6}{75}{UStuttAccent6Darker}
\colordarker{UStuttAccent6}{25}{UStuttAccent6VeryDark}

% Define humanly more readable colors
\colorlet{UStuttWhite}{UStuttLightOne}
\colorlet{UStuttAnthracite}{UStuttDarkOne}
\colorlet{UStuttGray}{UStuttAccent5}
\colorlet{UStuttTurquoise}{UStuttAccent1}
\colorlet{UStuttDarkBlue}{UStuttAccent2}
\colorlet{UStuttBluegray}{UStuttAccent4}
\colorlet{UStuttYellow}{UStuttAccent6}
\colorlet{UStuttHyperlink}{UStuttAccent1}% Bright light blue
\colorlet{UStuttHyperlinkFollowed}{UStuttDarkOne}

\colorlighter{UStuttWhite}{25}{UStuttWhiteVeryLight}
\colorlighter{UStuttWhite}{50}{UStuttWhiteLight}
\colorlighter{UStuttWhite}{75}{UStuttWhiteLighter}
\colordarker{UStuttWhite}{50}{UStuttWhiteDark}
\colordarker{UStuttWhite}{75}{UStuttWhiteDarker}
\colordarker{UStuttWhite}{25}{UStuttWhiteVeryDark}

\colorlighter{UStuttAnthracite}{25}{UStuttAnthraciteVeryLight}
\colorlighter{UStuttAnthracite}{50}{UStuttAnthraciteLight}
\colorlighter{UStuttAnthracite}{75}{UStuttAnthraciteLighter}
\colordarker{UStuttAnthracite}{50}{UStuttAnthraciteDark}
\colordarker{UStuttAnthracite}{75}{UStuttAnthraciteDarker}
\colordarker{UStuttAnthracite}{25}{UStuttAnthraciteVeryDark}

\colorlighter{UStuttGray}{25}{UStuttGrayVeryLight}
\colorlighter{UStuttGray}{50}{UStuttGrayLight}
\colorlighter{UStuttGray}{75}{UStuttGrayLighter}
\colordarker{UStuttGray}{50}{UStuttGrayDark}
\colordarker{UStuttGray}{75}{UStuttGrayDarker}
\colordarker{UStuttGray}{25}{UStuttGrayVeryDark}

\colorlighter{UStuttTurquoise}{25}{UStuttTurquoiseVeryLight}
\colorlighter{UStuttTurquoise}{50}{UStuttTurquoiseLight}
\colorlighter{UStuttTurquoise}{75}{UStuttTurquoiseLighter}
\colordarker{UStuttTurquoise}{50}{UStuttTurquoiseDark}
\colordarker{UStuttTurquoise}{75}{UStuttTurquoiseDarker}
\colordarker{UStuttTurquoise}{25}{UStuttTurquoiseVeryDark}

\colorlighter{UStuttDarkBlue}{25}{UStuttDarkBlueVeryLight}
\colorlighter{UStuttDarkBlue}{50}{UStuttDarkBlueLight}
\colorlighter{UStuttDarkBlue}{75}{UStuttDarkBlueLighter}
\colordarker{UStuttDarkBlue}{50}{UStuttDarkBlueDark}
\colordarker{UStuttDarkBlue}{75}{UStuttDarkBlueDarker}
\colordarker{UStuttDarkBlue}{25}{UStuttDarkBlueVeryDark}

\colorlighter{UStuttBluegray}{25}{UStuttBluegrayVeryLight}
\colorlighter{UStuttBluegray}{50}{UStuttBluegrayLight}
\colorlighter{UStuttBluegray}{75}{UStuttBluegrayLighter}
\colordarker{UStuttBluegray}{50}{UStuttBluegrayDark}
\colordarker{UStuttBluegray}{75}{UStuttBluegrayDarker}
\colordarker{UStuttBluegray}{25}{UStuttBluegrayVeryDark}

\colorlighter{UStuttYellow}{25}{UStuttYellowVeryLight}
\colorlighter{UStuttYellow}{50}{UStuttYellowLight}
\colorlighter{UStuttYellow}{75}{UStuttYellowLighter}
\colordarker{UStuttYellow}{50}{UStuttYellowDark}
\colordarker{UStuttYellow}{75}{UStuttYellowDarker}
\colordarker{UStuttYellow}{25}{UStuttYellowVeryDark}


% Regular text styling is like so
\setbeamercolor{normal text}{%
  fg=UStuttAnthracite,%
  bg=UStuttWhite,%
}%

% turquoise accent
\newcommand{\ustutt@colors@bright}{%
  \setbeamercolor{palette primary}{%
    fg=UStuttWhite,%
    bg=UStuttTurquoise,%
  }%
  \setbeamercolor{palette secondary}{%
    fg=UStuttWhite,%
    bg=UStuttDarkBlue,%
  }%
  \setbeamercolor{palette tertiary}{%
    fg=UStuttWhite,%
    bg=UStuttYellow,%
  }%
  \setbeamercolor{palette quatenary}{%
    use=palette primary,%
    fg=palette primary.bg,%
    bg=UStuttGray!20,%
  }%
  % \setbeamercolor{local structure}{%
  %   use=palette tertiary,% 
  %   fg=palette tertiary.bg,%
  % }%
  \setbeamercolor{alerted text}{%
    use=palette secondary,%
    fg=palette secondary.bg,%
  }%
  \setbeamercolor{inverted text}{%
    fg=UStuttWhite,%
    bg=UStuttDarkOne,%
  }%
  \setbeamercolor{example text}{%
    use=palette primary,%
    fg=palette primary.bg,%
  }%
  \usebeamercolor[fg]{normal text}%
}

% Dark blue accent
\newcommand{\ustutt@colors@dark}{%
  \setbeamercolor{palette primary}{%
    fg=UStuttWhite,%
    bg=UStuttDarkBlue,%
  }%
  \setbeamercolor{palette secondary}{%
    fg=UStuttWhite,%
    bg=UStuttTurquoise,%
  }%
  \setbeamercolor{palette tertiary}{%
    fg=UStuttWhite,%
    bg=UStuttYellow,%
  }%
  \setbeamercolor{palette quatenary}{%
    use=palette primary,%
    fg=palette primary.bg,%
    bg=UStuttGray!20,%
  }%
  % \setbeamercolor{local structure}{%
  %   use=palette tertiary,% 
  %   fg=palette tertiary.bg,%
  % }%
  \setbeamercolor{alerted text}{%
    use=palette secondary,%
    fg=palette secondary.bg,%
  }%
  \setbeamercolor{inverted text}{%
    fg=UStuttWhite,%
    bg=UStuttDarkOne,%
  }%
  \setbeamercolor{example text}{%
    use=palette primary,%
    fg=palette primary.bg,%
  }%
  \usebeamercolor[fg]{normal text}%
}

\setbeamercolor{background canvas}{
  bg=UStuttWhite,%
}

\setbeamercolor{titlelike}{%
  use=normal text,%
  parent=normal text,%
  fg=normal text.fg,%
  bg=normal text.bg,%
}

\setbeamercolor{frametitle}{%
  use=normal text,%
  % fg=palette primary.bg,%
  % bg=UStuttWhite,%
}

\setbeamercolor{title}{
  fg=UStuttWhite,%
  bg=,
}
\setbeamercolor{title separator}{
  use=progress bar,%
  parent=progress bar,%
}
\setbeamercolor{title in head/foot}{%
  use=palette quatenary,%
  parent=palette quatenary,%
  fg=UStuttDarkOne,%
}

\setbeamercolor{subtitle}{%
  fg=UStuttWhite,%
  bg=,%
}

\setbeamercolor{section title}{%
  use=normal text,%
  fg=normal text.fg,%
  bg=normal text.bg,%
}
\setbeamercolor{section number projected}{%
  use=palette primary,%
  parent=palette primary,%
}
\setbeamercolor{subsection number projected}{%
  use=palette primary,%
  parent=palette primary,%
}

\setbeamercolor{subsection title}{%
  use=normal text,%
  fg=normal text.bg,%
  bg=normal text.fg,%
}

\setbeamercolor{author}{%
  use=normal text,%
  parent=normal text,%
}
\setbeamercolor{author in head/foot}{%
  use=palette primary,%
  parent=palette primary,%
}

\setbeamercolor{date}{%
  use=normal text,%
  parent=normal text,%
}
\setbeamercolor{date in head/foot}{%
  use=palette primary,%
  parent=palette primary,%
}

\setbeamercolor{page number in head/foot}{%
  use=palette primary,%
  parent=palette primary,%
}

\setbeamercolor{institute}{%
  use=normal text,%
  parent=normal text,%
}
\setbeamercolor{progress bar}{%
  use=palette primary,%
  fg=palette primary.bg,%
  bg=UStuttLightTwoLighter,%
}
\setbeamercolor{progress bar in head/foot}{%
  use=progress bar,%
  parent=progress bar,%
}
\setbeamercolor{progress bar in section page}{%
  use=progress bar,%
  parent=progress bar,%
}

\setbeamercolor{itemize item}{
  use=palette primary,%
  fg=palette primary.bg,%
  bg=palette primary.bg,%
}%
\setbeamercolor{item}{
  use=palette primary,%
  fg=palette primary.bg,%
  bg=palette primary.bg,%
}%
\setbeamercolor{itemize subitem}{
  use=palette primary,%
  fg=palette primary.bg,%
  bg=palette primary.bg,%
}%
\setbeamercolor{itemize subsubitem}{
  use=palette primary,%
  fg=palette primary.bg,%
  bg=palette primary.bg,%
}%

\setbeamercolor{section in toc}{
  use=palette primary,%
}%
\setbeamercolor{subsection in toc}{
  use=palette primary,%
}%
\setbeamercolor{subsubsection in toc}{
  use=palette primary,%
}%

\newcommand{\ustutt@block@transparent}{
  \setbeamercolor{block title}{%
    use={normal text,palette primary},%
    fg=normal text.fg,%
    bg=normal text.bg,%
  }
  \setbeamercolor{block title alerted}{%
    use={block title,alerted text},%
    fg=alerted text.fg,%
    bg=block title.bg,%
  }
  \setbeamercolor{block title example}{%
    use={block title,example text},%
    fg=example text.fg,%
    bg=block title.bg,%
  }
  \setbeamercolor{block body}{%
    use=normal text,%
    bg=normal text.bg,%
  }
  \setbeamercolor{block body alerted}{%
    use={block body,alerted text},%
    fg=alerted text.fg,%
    bg=block body.bg,%
  }
  \setbeamercolor{block body example}{%
    use={block body,example text},%
    fg=example text.fg,%
    bg=block body.bg,%
  }
}
\newcommand{\ustutt@block@fill}{
  \setbeamercolor{block title}{%
    use={normal text,palette primary},%
    fg=normal text.bg,%
    bg=normal text.fg,%
  }
  \setbeamercolor{block title alerted}{%
    use={block title,alerted text},%
    fg=alerted text.bg,%
    bg=alerted text.fg,%
  }
  \setbeamercolor{block title example}{%
    use={block title,example text},%
    fg=block title.bg,%
    bg=example text.fg,%
  }
  \setbeamercolor{block body}{%
    use=palette quatenary,%
    bg=palette quatenary.bg,%
  }
  \setbeamercolor{block body alerted}{%
    use={block body,normal text},%
    fg=normal text.fg,%
    bg=block body.bg,%
  }
  \setbeamercolor{block body example}{%
    use={block body,normal text},%
    fg=normal text.fg,%
    bg=block body.bg,%
  }
}

\setbeamercolor{block title takeaway}{%
  use={alerted text,palette primary},%
  fg=palette primary.fg,%
  bg=alerted text.fg,%
}
\setbeamercolor{block body takeaway}{%
  use={alerted text,palette primary},%
  fg=palette primary.fg,%
  bg=alerted text.fg,%
}

\setbeamercolor{footnote}{%
  % use=normal text,%
  % parent=normal text,%
  fg=normal text.fg!90,%
}
\setbeamercolor{footnote mark}{%
  % use=normal text,%
  % parent=normal text,%
  fg=normal text.fg%,
}

\setbeamercolor{bibliography entry author}{%
  use=normal text,%
}
\setbeamercolor{bibliography entry title}{%
  use=palette primary,%
  fg=palette primary.bg,%
  bg=palette primary.fg,%
}
\setbeamercolor{bibliography entry location}{%
  use=palette quatenary,%
}
\setbeamercolor{bibliography entry note}{%
  use=palette quatenary,%
}
\setbeamercolor{bibliography item}{%
  use=palette quatenary,%
}

\ustutt@color@setdefaults

\ProcessPgfPackageOptions{/ustutt/color}

\mode<all>

\endinput
